﻿namespace s4_visualizer
{
    class Log
    {
        public Log (System.Windows.Forms.RichTextBox _outputBox)
        {
            outputBox = _outputBox;
        }

        delegate void printDelegate (string msg);
        delegate void printDelegate2 (string msg, System.Drawing.Color color);

        // A thread-safe way to update the text
        public void print(string msg)
        {
            if (outputBox.InvokeRequired)
            {
                outputBox.Invoke(new printDelegate(printSafe), new object[]{msg});
            }
            else
            {
                printSafe(msg);
            }
        }

        // A thread-safe way to update the text
        public void print (string msg, System.Drawing.Color color)
        {
            if (outputBox.InvokeRequired)
            {
                outputBox.Invoke(new printDelegate2(printSafe), new object[]{msg, color});
            }
            else
            {
                printSafe(msg, color);
            }
        }

        private void printSafe (string msg)
        {
            outputBox.AppendText(msg);
        }

        private void printSafe (string msg, System.Drawing.Color color)
        {
            System.Drawing.Color prevColor = outputBox.SelectionColor;
            outputBox.SelectionStart = outputBox.TextLength;
            outputBox.SelectionLength = 0;

            outputBox.SelectionColor = color;
            outputBox.AppendText(msg);

            outputBox.SelectionColor = prevColor;
        }

        System.Windows.Forms.RichTextBox outputBox;
    }
}